/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.client.button;

import javax.annotation.Nonnull;

import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.resources.I18n;
import net.minecraft.item.ItemStack;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import net.dries007.tfc.api.recipes.anvil.AnvilRecipe;
import net.dries007.tfc.objects.te.TEAnvilTFC;

import static net.dries007.tfc.client.gui.GuiAnvilTFC.ANVIL_BACKGROUND;

@SideOnly(Side.CLIENT)
public class GuiButtonAnvilPlan extends GuiButtonTFC implements IButtonTooltip
{
    private final String tooltip;
    private final TEAnvilTFC tile;

    public GuiButtonAnvilPlan(TEAnvilTFC tile, int id, int guiLeft, int guiTop)
    {
        // Plan Button
        super(id, guiLeft + 21, guiTop + 40, 18, 18, "");
        this.tooltip = I18n.func_135052_a("tfc.tooltip.anvil_plan");
        this.tile = tile;
    }

    @Override
    public void func_191745_a(@Nonnull Minecraft mc, int mouseX, int mouseY, float partialTicks)
    {
        if (this.field_146125_m)
        {
            GlStateManager.func_179131_c(1, 1, 1, 1);
            mc.func_110434_K().func_110577_a(ANVIL_BACKGROUND);
            field_146123_n = mouseX >= this.field_146128_h && mouseY >= this.field_146129_i && mouseX < this.field_146128_h + this.field_146120_f && mouseY < this.field_146129_i + this.field_146121_g;
            func_146110_a(field_146128_h, field_146129_i, 218, 0, 18, 18, 256, 256);
            AnvilRecipe recipe = tile.getRecipe();
            if (recipe != null)
            {
                ItemStack stack = recipe.getPlanIcon();
                drawItemStack(stack, field_146128_h + 1, field_146129_i + 1);
            }
            else
            {
                func_73729_b(field_146128_h + 1, field_146129_i + 1, 236, 0, 16, 16);
            }
            func_146119_b(mc, mouseX, mouseY);
        }
    }

    @Override
    public String getTooltip()
    {
        return tooltip;
    }

    @Override
    public boolean hasTooltip()
    {
        return tooltip != null;
    }
}
