/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.client.model.animal;

import javax.annotation.ParametersAreNonnullByDefault;

import net.minecraft.client.model.ModelQuadruped;
import net.minecraft.client.model.ModelRenderer;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.entity.Entity;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import net.dries007.tfc.objects.entity.animal.EntityAnimalTFC;
import net.dries007.tfc.objects.entity.animal.EntitySheepTFC;

@SideOnly(Side.CLIENT)
@ParametersAreNonnullByDefault
public class ModelSheepBodyTFC extends ModelQuadruped
{
    private ModelRenderer horn1;
    private ModelRenderer horn2;
    private ModelRenderer horn1b;
    private ModelRenderer horn2b;

    public ModelSheepBodyTFC()
    {
        super(12, 0.0F);
        this.field_78150_a = new ModelRenderer(this, 0, 0);
        this.field_78150_a.func_78790_a(-3.0F, -4.0F, -6.0F, 6, 6, 8, 0.0F);
        this.field_78150_a.func_78793_a(0.0F, 6.0F, -8.0F);
        this.field_78148_b = new ModelRenderer(this, 28, 8);
        this.field_78148_b.func_78790_a(-4.0F, -10.0F, -7.0F, 8, 16, 6, 0.0F);
        this.field_78148_b.func_78793_a(0.0F, 5.0F, 2.0F);

        horn1 = new ModelRenderer(this, 28, 2);
        horn1.func_78790_a(0F, 0F, 0F, 2, 4, 2, 0F);
        horn1.func_78793_a(0F, -10F, 0F);
        horn1.field_78808_h = (float) -Math.PI / 6;
        horn1.field_78795_f = (float) -Math.PI / 6;
        horn1.field_78796_g = (float) -Math.PI / 3;
        horn1.func_78793_a(-5F, -6F, -1F);

        horn1b = new ModelRenderer(this, 38, 4);
        horn1b.func_78790_a(0.5F, 1F, 0.5F, 1, 3, 1, 0.25F);
        horn1b.func_78793_a(0F, -2F, 4F);
        horn1b.field_78795_f = (float) -Math.PI / 3;

        horn2 = new ModelRenderer(this, 28, 2);
        horn2.func_78790_a(0F, 0F, 0F, 2, 4, 2, 0F);
        horn2.func_78793_a(0F, -10F, 0F);
        horn2.field_78808_h = (float) Math.PI / 6;
        horn2.field_78795_f = (float) -Math.PI / 6;
        horn2.field_78796_g = (float) Math.PI / 3;
        horn2.func_78793_a(4F, -6.5F, 0.75F);

        horn2b = new ModelRenderer(this, 38, 4);
        horn2b.func_78790_a(0.5F, 1F, 0.5F, 1, 3, 1, 0.25F);
        horn2b.func_78793_a(0F, -2F, 4F);
        horn2b.field_78795_f = (float) -Math.PI / 3;

        horn1.func_78792_a(horn1b);
        horn2.func_78792_a(horn2b);

        field_78150_a.func_78792_a(horn1);
        field_78150_a.func_78792_a(horn2);
    }

    @Override
    public void func_78088_a(Entity entity, float par2, float par3, float par4, float par5, float par6, float par7)
    {
        this.func_78087_a(par2, par3, par4, par5, par6, par7, entity);
        EntitySheepTFC sheep = ((EntitySheepTFC) entity);

        float percent = sheep.getPercentToAdulthood();
        float ageScale = 2.0F - percent;
        float ageHeadScale = (float) Math.pow(1 / ageScale, 0.66);

        GlStateManager.func_179094_E();

        GlStateManager.func_179109_b(0.0F, 0.75f - (0.75f * percent), 0f);
        GlStateManager.func_179152_a(ageHeadScale, ageHeadScale, ageHeadScale);
        GlStateManager.func_179109_b(0.0F, (ageScale - 1) * -0.125f, 0.1875f - (0.1875f * percent));


        if (percent < 0.5)
        {
            horn1.field_78807_k = true;
            horn2.field_78807_k = true;
            if (percent < 0.75)
            {
                horn1b.field_78807_k = true;
                horn2b.field_78807_k = true;
            }
        }

        if (sheep.getGender() == EntityAnimalTFC.Gender.FEMALE)
        {
            horn1.field_78807_k = true;
            horn2.field_78807_k = true;
        }
        this.field_78150_a.func_78785_a(par7);

        GlStateManager.func_179121_F();
        GlStateManager.func_179094_E();
        GlStateManager.func_179109_b(0.0F, 0.75f - (0.75f * percent), 0f);
        GlStateManager.func_179152_a(1 / ageScale, 1 / ageScale, 1 / ageScale);

        this.field_78148_b.func_78785_a(par7);
        this.field_78149_c.func_78785_a(par7);
        this.field_78146_d.func_78785_a(par7);
        this.field_78147_e.func_78785_a(par7);
        this.field_78144_f.func_78785_a(par7);
        horn1.field_78807_k = false;
        horn1b.field_78807_k = false;
        horn2.field_78807_k = false;
        horn2b.field_78807_k = false;
        GlStateManager.func_179121_F();
    }
}
