/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.client.render;

import org.lwjgl.opengl.GL11;
import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.BufferBuilder;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.Tessellator;
import net.minecraft.client.renderer.block.model.ItemCameraTransforms;
import net.minecraft.client.renderer.texture.TextureAtlasSprite;
import net.minecraft.client.renderer.texture.TextureMap;
import net.minecraft.client.renderer.tileentity.TileEntitySpecialRenderer;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import net.minecraft.item.ItemStack;
import net.minecraftforge.fluids.Fluid;
import net.minecraftforge.fluids.FluidStack;
import net.minecraftforge.fluids.capability.CapabilityFluidHandler;
import net.minecraftforge.fluids.capability.IFluidHandler;
import net.minecraftforge.fluids.capability.IFluidTankProperties;
import net.minecraftforge.items.CapabilityItemHandler;
import net.minecraftforge.items.IItemHandler;

import net.dries007.tfc.client.FluidSpriteCache;
import net.dries007.tfc.objects.blocks.wood.BlockBarrel;
import net.dries007.tfc.objects.te.TEBarrel;

public class TESRBarrel extends TileEntitySpecialRenderer<TEBarrel>
{

    @Override
    public void func_192841_a(TEBarrel te, double x, double y, double z, float partialTicks, int destroyStage, float alpha)
    {
        if (te.func_145831_w().func_180495_p(te.func_174877_v()).func_177229_b(BlockBarrel.SEALED))
        {
            return;
        }

        IFluidHandler fluidHandler = te.getCapability(CapabilityFluidHandler.FLUID_HANDLER_CAPABILITY, null);
        IItemHandler itemHandler = te.getCapability(CapabilityItemHandler.ITEM_HANDLER_CAPABILITY, null);

        if (fluidHandler == null || itemHandler == null)
        {
            return;
        }

        IFluidTankProperties properties = fluidHandler.getTankProperties()[0];
        FluidStack fluidStack = properties.getContents();
        ItemStack stack = itemHandler.getStackInSlot(TEBarrel.SLOT_ITEM);

        GlStateManager.func_179094_E();
        GlStateManager.func_179137_b(x, y, z);

        if (!stack.func_190926_b())
        {
            GlStateManager.func_179094_E();
            GlStateManager.func_179137_b(0.5D, 0.15625D, 0.5D);
            GlStateManager.func_179152_a(0.5F, 0.5F, 0.5F);
            GlStateManager.func_179114_b(90F, 1F, 0F, 0F);
            Minecraft.func_71410_x().func_175599_af().func_181564_a(stack, ItemCameraTransforms.TransformType.FIXED);
            GlStateManager.func_179121_F();
        }

        if (fluidStack != null)
        {
            Fluid fluid = fluidStack.getFluid();

            TextureAtlasSprite sprite = FluidSpriteCache.getSprite(fluid);

            GlStateManager.func_179141_d();
            GlStateManager.func_179147_l();
            GlStateManager.func_187428_a(GlStateManager.SourceFactor.SRC_ALPHA, GlStateManager.DestFactor.ONE_MINUS_SRC_ALPHA, GlStateManager.SourceFactor.ONE, GlStateManager.DestFactor.ZERO);

            int color = fluid.getColor();

            float r = ((color >> 16) & 0xFF) / 255F;
            float g = ((color >> 8) & 0xFF) / 255F;
            float b = (color & 0xFF) / 255F;
            float a = ((color >> 24) & 0xFF) / 255F;

            GlStateManager.func_179131_c(r, g, b, a);

            field_147501_a.field_147553_e.func_110577_a(TextureMap.field_110575_b);

            BufferBuilder buffer = Tessellator.func_178181_a().func_178180_c();
            buffer.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_181710_j);

            FluidStack content = properties.getContents();

            if (content == null)
            {
                return;
            }

            double height = 0.140625D + (0.75D - 0.015625D) * content.amount / properties.getCapacity();

            buffer.func_181662_b(0.1875D, height, 0.1875D).func_187315_a(sprite.func_94214_a(3), sprite.func_94207_b(3)).func_181663_c(0, 0, 1).func_181675_d();
            buffer.func_181662_b(0.1875D, height, 0.8125D).func_187315_a(sprite.func_94214_a(3), sprite.func_94207_b(13)).func_181663_c(0, 0, 1).func_181675_d();
            buffer.func_181662_b(0.8125D, height, 0.8125D).func_187315_a(sprite.func_94214_a(13), sprite.func_94207_b(13)).func_181663_c(0, 0, 1).func_181675_d();
            buffer.func_181662_b(0.8125D, height, 0.1875D).func_187315_a(sprite.func_94214_a(13), sprite.func_94207_b(3)).func_181663_c(0, 0, 1).func_181675_d();

            Tessellator.func_178181_a().func_78381_a();
        }

        GlStateManager.func_179121_F();
    }
}
