/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.client.render;

import org.lwjgl.opengl.GL11;
import net.minecraft.client.renderer.BufferBuilder;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.Tessellator;
import net.minecraft.client.renderer.texture.TextureAtlasSprite;
import net.minecraft.client.renderer.texture.TextureMap;
import net.minecraft.client.renderer.tileentity.TileEntitySpecialRenderer;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import net.minecraftforge.fluids.Fluid;
import net.minecraftforge.fluids.FluidStack;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import net.dries007.tfc.api.types.Metal;
import net.dries007.tfc.client.FluidSpriteCache;
import net.dries007.tfc.objects.fluids.FluidsTFC;
import net.dries007.tfc.objects.te.TECrucible;

/**
 * Render molten metal inside crucible
 */
@SideOnly(Side.CLIENT)
public class TESRCrucible extends TileEntitySpecialRenderer<TECrucible>
{

    @Override
    public void func_192841_a(TECrucible te, double x, double y, double z, float partialTicks, int destroyStage, float alpha)
    {
        int amount = te.getAlloy().getAmount();
        if (amount < 1) return;
        Metal metal = te.getAlloyResult();
        Fluid metalFluid = FluidsTFC.getMetalFluid(metal);
        FluidStack moltenMetal = new FluidStack(metalFluid, amount);

        GlStateManager.func_179094_E();
        GlStateManager.func_179137_b(x, y, z);

        TextureAtlasSprite sprite = FluidSpriteCache.getSprite(metalFluid);

        GlStateManager.func_179141_d();
        GlStateManager.func_179147_l();
        GlStateManager.func_187428_a(GlStateManager.SourceFactor.SRC_ALPHA, GlStateManager.DestFactor.ONE_MINUS_SRC_ALPHA, GlStateManager.SourceFactor.ONE, GlStateManager.DestFactor.ZERO);

        int color = metalFluid.getColor();

        float r = ((color >> 16) & 0xFF) / 255F;
        float g = ((color >> 8) & 0xFF) / 255F;
        float b = (color & 0xFF) / 255F;
        float a = ((color >> 24) & 0xFF) / 255F;

        GlStateManager.func_179131_c(r, g, b, a);

        field_147501_a.field_147553_e.func_110577_a(TextureMap.field_110575_b);

        BufferBuilder buffer = Tessellator.func_178181_a().func_178180_c();
        buffer.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_181710_j);

        double height = 0.140625D + (0.75D - 0.015625D) * amount / TECrucible.CRUCIBLE_MAX_METAL_FLUID;

        buffer.func_181662_b(0.1875D, height, 0.1875D).func_187315_a(sprite.func_94214_a(3), sprite.func_94207_b(3)).func_181663_c(0, 0, 1).func_181675_d();
        buffer.func_181662_b(0.1875D, height, 0.8125D).func_187315_a(sprite.func_94214_a(3), sprite.func_94207_b(13)).func_181663_c(0, 0, 1).func_181675_d();
        buffer.func_181662_b(0.8125D, height, 0.8125D).func_187315_a(sprite.func_94214_a(13), sprite.func_94207_b(13)).func_181663_c(0, 0, 1).func_181675_d();
        buffer.func_181662_b(0.8125D, height, 0.1875D).func_187315_a(sprite.func_94214_a(13), sprite.func_94207_b(3)).func_181663_c(0, 0, 1).func_181675_d();

        Tessellator.func_178181_a().func_78381_a();

        GlStateManager.func_179121_F();
    }
}
