/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.client.render.animal;

import javax.annotation.ParametersAreNonnullByDefault;

import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.entity.layers.LayerRenderer;
import net.minecraft.entity.passive.EntitySheep;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import net.dries007.tfc.client.model.animal.ModelSheepWoolTFC;
import net.dries007.tfc.objects.entity.animal.EntitySheepTFC;

@SideOnly(Side.CLIENT)
@ParametersAreNonnullByDefault
public class LayerSheepWoolTFC implements LayerRenderer<EntitySheepTFC>
{
    private static final ResourceLocation TEXTURE = new ResourceLocation("minecraft:textures/entity/sheep/sheep_fur.png");
    private final RenderSheepTFC sheepRenderer;
    private final ModelSheepWoolTFC sheepModel = new ModelSheepWoolTFC();

    public LayerSheepWoolTFC(RenderSheepTFC sheepRendererIn)
    {
        this.sheepRenderer = sheepRendererIn;
    }

    @Override
    public void func_177141_a(EntitySheepTFC sheep, float limbSwing, float limbSwingAmount, float partialTicks, float ageInTicks, float netHeadYaw, float headPitch, float scale)
    {
        if (sheep.hasWool() && !sheep.func_82150_aj())
        {
            this.sheepRenderer.func_110776_a(TEXTURE);

            float[] afloat = EntitySheep.func_175513_a(sheep.getDyeColor());
            GlStateManager.func_179124_c(afloat[0], afloat[1], afloat[2]);

            this.sheepModel.func_178686_a(this.sheepRenderer.func_177087_b());
            this.sheepModel.func_78086_a(sheep, limbSwing, limbSwingAmount, partialTicks);
            this.sheepModel.func_78088_a(sheep, limbSwing, limbSwingAmount, ageInTicks, netHeadYaw, headPitch, scale);
        }
    }

    @Override
    public boolean func_177142_b()
    {
        return true;
    }
}
