/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.objects.items.metal;

import javax.annotation.Nonnull;

import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.EnumAction;
import net.minecraft.item.ItemBow;
import net.minecraft.item.ItemStack;
import net.minecraft.stats.StatList;
import net.minecraft.util.ActionResult;
import net.minecraft.util.EnumActionResult;
import net.minecraft.util.EnumHand;
import net.minecraft.util.SoundCategory;
import net.minecraft.world.World;

import net.dries007.tfc.Constants;
import net.dries007.tfc.api.types.Metal;
import net.dries007.tfc.client.TFCSounds;
import net.dries007.tfc.objects.entity.projectile.EntityThrownJavelin;

import net.minecraft.item.Item.ToolMaterial;

public class ItemMetalJavelin extends ItemMetalTool
{
    public ItemMetalJavelin(Metal metal, Metal.ItemType type)
    {
        super(metal, type);

        ToolMaterial material = metal.getToolMetal();
        if (material != null)
        {
            func_77656_e((int) (material.func_77997_a() * 0.1));
        }
    }

    @Override
    @Nonnull
    public ActionResult<ItemStack> func_77659_a(World worldIn, EntityPlayer playerIn, @Nonnull EnumHand handIn)
    {
        if (type == Metal.ItemType.JAVELIN)
        {
            ItemStack itemstack = playerIn.func_184586_b(handIn);
            playerIn.func_184598_c(handIn);
            return new ActionResult<>(EnumActionResult.SUCCESS, itemstack);
        }
        return super.func_77659_a(worldIn, playerIn, handIn);
    }

    @Override
    @Nonnull
    public EnumAction func_77661_b(ItemStack stack)
    {
        return EnumAction.BOW;
    }

    @Override
    public int func_77626_a(ItemStack stack)
    {
        return 72000;
    }

    @SuppressWarnings("ConstantConditions")
    @Override
    public void func_77615_a(ItemStack stack, World worldIn, EntityLivingBase entityLiving, int timeLeft)
    {
        if (entityLiving instanceof EntityPlayer && type == Metal.ItemType.JAVELIN)
        {
            EntityPlayer player = (EntityPlayer) entityLiving;
            int charge = this.func_77626_a(stack) - timeLeft;
            if (charge > 5)
            {
                float f = ItemBow.func_185059_b(charge); //Same charge time as bow

                if (!worldIn.field_72995_K)
                {
                    EntityThrownJavelin javelin = new EntityThrownJavelin(worldIn, player);
                    javelin.func_70239_b(this.getAttackDamage());
                    javelin.setWeapon(stack);
                    javelin.func_184547_a(player, player.field_70125_A, player.field_70177_z, 0.0F, f * 1.5F, 0.5F);
                    worldIn.func_72838_d(javelin);
                    worldIn.func_184148_a(null, player.field_70165_t, player.field_70163_u, player.field_70161_v, TFCSounds.ITEM_THROW, SoundCategory.PLAYERS, 1.0F, 1.0F / (Constants.RNG.nextFloat() * 0.4F + 1.2F) + f * 0.5F);
                }
                player.field_71071_by.func_184437_d(stack);
                player.func_71029_a(StatList.func_188057_b(this));
            }
        }
    }
}
