/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.objects.te;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import javax.annotation.ParametersAreNonnullByDefault;

import net.minecraft.block.Block;
import net.minecraft.block.BlockChest;
import net.minecraft.block.state.IBlockState;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntityChest;
import net.minecraft.util.NonNullList;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import mcp.MethodsReturnNonnullByDefault;
import net.dries007.tfc.api.types.Tree;
import net.dries007.tfc.objects.blocks.wood.BlockChestTFC;

@ParametersAreNonnullByDefault
@MethodsReturnNonnullByDefault
public class TEChestTFC extends TileEntityChest
{
    public static final int SIZE = 18;

    private Tree cachedWood;

    {
        field_145985_p = NonNullList.func_191197_a(SIZE, ItemStack.field_190927_a); // todo: make chest size configurable.
    }

    @Override
    @SideOnly(Side.CLIENT)
    @Nonnull
    public AxisAlignedBB getRenderBoundingBox()
    {
        return new AxisAlignedBB(func_174877_v().func_177982_a(-1, 0, -1), func_174877_v().func_177982_a(2, 2, 2));
    }

    @Nullable
    public Tree getWood()
    {
        if (cachedWood == null)
        {
            if (field_145850_b != null)
            {
                cachedWood = ((BlockChestTFC) field_145850_b.func_180495_p(field_174879_c).func_177230_c()).wood;
            }
        }
        return cachedWood;
    }

    @Override
    public int func_70302_i_()
    {
        return SIZE;
    }

    @Override
    protected boolean func_174912_b(@Nonnull BlockPos posIn)
    {
        if (field_145850_b == null) return false;

        Block block = this.field_145850_b.func_180495_p(posIn).func_177230_c();
        return block instanceof BlockChestTFC && ((BlockChestTFC) block).wood == getWood() && ((BlockChest) block).field_149956_a == func_145980_j();
    }

    @Override
    public boolean shouldRefresh(World world, BlockPos pos, IBlockState oldState, IBlockState newSate)
    {
        return oldState.func_177230_c() != newSate.func_177230_c();
    }
}
